<template>
    <Modal
        :show="show"
        hide-header
        hide-footer
        size="small"
        :title="title"
        :content-class="['modal_add_credits', 'modal_blue_close_btn']"
        :close-button="{width: '12px', height: '12px', src: '/images/close-gray.svg'}"
        @close="$emit('close')"
    >
        <div
            v-if="currentOption"
            class="credits__content"
        >
            Credits to add: 
            <b-dropdown
                text="Button text via Prop"
                toggle-class="text-decoration-none"
                class="dropdown"
                no-caret
            >  
                <template #button-content>
                    <div style="position: relative">
                        <div class="credits__option current_option">
                            <span
                                v-if="currentOption.text"
                                class="option__text"
                            >{{ currentOption.text }}</span>
                            <span
                                v-if="allOptionsReady"
                                class="option__hr"
                            >-</span>
                            <span
                                v-if="currentOption.price"
                                class="option__price"
                            >{{ currentOption.price }}</span>
                        </div>
                        <img
                            class="arrow"
                            src="/images/down-arrow.svg"
                            alt=""
                        >
                    </div>
                </template>
                <b-dropdown-item
                    v-for="option in items"
                    :key="option.text"
                    href="#"
                    class="credits__option"
                    @click="currentOption = option"
                >
                    <span
                        v-if="option.text"
                        class="option__text"
                    >{{ option.text }}</span>
                    <span
                        v-if="allOptionsReady"
                        class="option__hr"
                    >-</span>
                    <span
                        v-if="option.price"
                        class="option__price"
                    >{{ option.price }}</span>
                </b-dropdown-item>
            </b-dropdown>
        </div>
        <b-button
            variant="primary"
            class="btn"
            :class="{'loading-xs': loading}"
            @click="addCreadits"
        >
            {{ !loading ? 'Secure Buy With Wix' : '' }}
        </b-button>
    </Modal>
</template>

<script>
import Modal from '@/components/elements/Modal'

export default {
    components: {
        Modal
    },
    props: ['items', 'show', 'title'],
    data() {
        return {
            currentOption: null,
            loading: false,
        }
    },
    computed: {
        allOptionsReady() {
            if(!this.currentOption) return
            return this.currentOption.text && this.currentOption.price
        }
    },
    created() {
        this.currentOption = this.items[0]
    },
    methods: {
        addCreadits() {
            this.loading = true
            this.$emit('addCredits', this.currentOption)
        }
    }
}
</script>


<style lang="scss" scoped>
.credits__option {
    display: flex;
    // justify-content: space-between;
    list-style: none;
    .option {
        &__price {
            color: #4786FF;
        }
        &__hr {
            padding: 0 14px;
        }
    }
}
.dropdown.show {
    .arrow {
        transform: translateY(-50%) rotate(180deg); 
    }
}
.arrow {
    width: 24px;
    height: 12px;
    right: -5px;
    z-index: 100;
    top: 50%;
    transform: translateY(-50%);
}
.current_option {
    text-align: left;
}

.credits__content {
    margin: 8px 0 24px;
    display: flex;
    align-items: center;
    justify-content: flex-start;
    .dropdown {
        margin-left: 8px;
    }
}
.btn {
    width: 224px;
    height: 36px;
}

</style>

<style lang="scss">
.modal_add_credits {
    width: 358px!important;
    .modal-popup-body {
        padding: 16px;
    }
    .popup-header-text {
        font-size: 18px;
        line-height: 21px;
        padding: 16px 0 13px;
    }
}

.dropdown, .dropdown-menu {
    width: 225px;
    .dropdown-item {
        padding: 0.375rem 12px;
    }
}
.dropdown {
    border: 1px solid #D7D9DB;
    text-align: left;
    height: 36px;
    border-radius: 4px;
    .btn {
        padding: 0.375rem 12px;
    }
    .btn-secondary, .btn-secondary:hover, .btn-secondary:focus, .btn-secondary:active, .show > .btn-secondary.dropdown-toggle {
        border: none!important;
        background: none!important;
        background-color: none!important;
        color: #000!important;
    }
}
</style>
